const State = require('../State')

class PackageCacheClearedState extends State {
    static get services() {
        return [...super.services, 'output']
    }

    constructor(host, config) {
        if ( !host.packages ) {
            throw new Error(`Cannot apply package state to host ${host.name}: missing package manager API.`)
        }
        super(host, config)
    }

    async apply() {
        return this._host.packages.clear_cache()
    }

    async check() {
        return false
    }

    async reverse() {
        this.output.warn(`Package cache cleared state does not currently support reversal. (Host: ${this._host.name})`)
    }
}

module.exports = exports = PackageCacheClearedState
